package jogo;

import java.awt.Graphics;

public class Jogador extends Elementos {

    private int cima; // código da tecla para mover para cima
    private int baixo;// código da tecla para mover para baixo
    private int direita;// código da tecla para mover para direita
    private int esquerda;// código da tecla para mover para esquerda
    private int atira;
    public boolean atirando;
    private JogoPrincipal p;
    private int combustivel;
    

    public Jogador(int posx, int posy, int cima, int baixo, int direita, int esquerda, int atira, JogoPrincipal jp, String img) {
        super(posx, posy, img);
        this.cima = cima;
        this.baixo = baixo;
        this.direita = direita;
        this.esquerda = esquerda;
        this.atira = atira;
        this.atirando = false;
        this.p = jp;
        this.altura = 20;
        this.largura = 20;
        this.icone = this.carregarImagem(this.imagemNome);
        this.combustivel = 100;
        
    }

    public void desenhar(Graphics g) {
        g.drawImage(this.icone, this.posx, this.posy, this.jpTela);

    }

    public void diminuiComb() {
        if (this.combustivel > 0) {
            this.combustivel--;
        }
    }

    public void aumentaComb() {
        if (this.combustivel < 100) {
            this.combustivel++;
        }
    }

    public void explode(String s) {
        this.icone = this.carregarImagem(s);
    }

    public int getPosx() {
        return posx;
    }

    public void setPosx(int posx) {
        this.posx = posx;
    }

    public int getPosy() {
        return posy;
    }

    public void setPosy(int posy) {
        this.posy = posy;
    }

    public void atualizarCoord() {

        this.atirando = false;

        if (p.teclado.teclaApertada(this.esquerda)) {
            this.posx--;
        }
        if (p.teclado.teclaApertada(this.direita)) {
            this.posx++;
        }
        if (p.teclado.teclaApertadaPrimeiraVez(atira)) {
            this.atirando = true;

        }

    }

    public boolean atirar() {
        return atirando;
    }

    public int getAltura() {
        return altura;
    }

    public int getLargura() {
        return largura;
    }

    public int getCombustivel() {
        return combustivel;
    }

    public void setCombustivel(int combustivel) {
        this.combustivel = combustivel;
    }

}