package jogo;

import java.awt.event.ActionEvent;
import java.awt.Graphics;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.ImageIcon;
import java.awt.Image;
import javax.swing.JPanel;
import javax.swing.Timer;
import java.awt.Color;

public class Tela extends JPanel implements ActionListener {

    public JogoPrincipal principal;
    private Jogador nave;
    public int[][] matriz;
    private int posY;
    private int larguraBloco;
    private int linhas;
    private int colunas;
    private int relogio;
    private int relogioComb;
    private int quantidadeLinhas, bloco;
    private int pontos;
    private int vidas;
    private Random sorteio;
    private Timer timer;
    private Image imgcenarios[];
    private ArrayList<Inimigos> inimigos;
    private ArrayList<Posto> posto;
    private ArrayList<Cenario> cenarios;
    private ArrayList<Tiro> tiro;

    public Tela(JogoPrincipal p) {
        this.principal = p;
        this.posY = 10;
        this.timer = new Timer(10, this); //milisegundos, classe a ser adicionada
        this.setIgnoreRepaint(true); //evitando o auto repaint
        this.setBackground(Color.white); //mudando a cor de fundo da tela
        this.sorteio = new Random();
        this.inimigos = new ArrayList<Inimigos>();
        this.tiro = new ArrayList<Tiro>();
        this.cenarios = new ArrayList<Cenario>();
        this.posto = new ArrayList<Posto>();
        this.relogio = 0;
        this.relogioComb = 0;
        this.imgcenarios = new Image[2];
        this.imgcenarios[0] = (new ImageIcon(this.getClass().getResource("/imagens/azul.png"))).getImage();
        this.imgcenarios[1] = (new ImageIcon(this.getClass().getResource("/imagens/verde.png"))).getImage();
        this.larguraBloco = 20;
        this.linhas = 0;
        this.colunas = 32;
        this.matriz = new int[25][32];
        this.quantidadeLinhas = 15;
        this.bloco = this.sorteio.nextInt(3);
        this.vidas = 3;
        
        this.criaCenario();
        System.arraycopy(this.cenarios.get(this.bloco).getMat(), this.linhas, this.matriz, 0, this.quantidadeLinhas);

    }

    public final void criaCenario() {
        int[][] cenario1 = { //25x32 (linha,coluna)
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},};

        int[][] cenario2 = { //25x32 (linha,coluna)
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1},
            {1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1},};

        int[][] cenario3 = { //25x32 (linha,coluna)
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},
            {1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1},};

        this.cenarios.add(new Cenario(cenario1));
        this.cenarios.add(new Cenario(cenario2));
        this.cenarios.add(new Cenario(cenario3));

    }

    public void iniciaJogo() {
        this.criaCenario();
        this.criaJogador();
        this.timer.start();
        String vidas1 = ("" + this.vidas);
        principal.jTFvidas.setText(vidas1);
        principal.jPBcombustivel.setValue(nave.getCombustivel());
    }

    public void paint(Graphics g) {
        super.paint(g);
        //desenhar cenario
        this.desenharCenario(g);

        //desenhar nave
        if (nave != null) {
            nave.desenhar(g);
        }

        //desenhando todos os retangulos vermelhos
        for (Inimigos r : inimigos) {
            r.desenhar(g);
        }

        //desenhando todos os postos
        for (Posto p : posto) {
            p.desenhar(g);
        }

        //desenhando todos os tiros
        for (Tiro t : tiro) {
            t.desenhar(g);
        }

        g.dispose();
    }

    public void atualizarCenario() {
        //Diminui combustivel, se  combustivel igual a zero perde uma vida
        if (nave.getCombustivel() > 0) {
            nave.diminuiComb();
            principal.jPBcombustivel.setValue(nave.getCombustivel());
        } else {
            this.perdeVida();
        }

        //deslocamento
        for (Cenario c : cenarios) {
            System.arraycopy(this.cenarios.get(this.bloco).getMat(), this.linhas, this.matriz, 0, this.quantidadeLinhas);
        }
        //copia do arraylist
        System.arraycopy(matriz, 0, matriz, 1, 24);
        quantidadeLinhas = 1;
        if (this.linhas > 0) {
            this.linhas--;
        } else {
            this.linhas = 24;
            this.bloco = this.sorteio.nextInt(3);
        }

    }

    public void criaJogador() {
        int lin = 0;
        int col = 0;
        int x = 0;
        int y = 0;

        x = getWidth() / 2 - 20;
        y = getHeight() - 50;

        col = x / 20;
        lin = y / 20;

        if ((matriz[lin][col] == 0) && (matriz[lin][col + 1] == 0)) {

            if (nave != null) {
                this.verifCriaJogador(x, y, lin, col);
            } else {
                nave = new Jogador(x, y, KeyEvent.VK_UP, KeyEvent.VK_DOWN,
                        KeyEvent.VK_RIGHT, KeyEvent.VK_LEFT, KeyEvent.VK_SPACE, principal, "nave");
            }

        } else {

            do {
                x = this.sorteio.nextInt(462) + 80;
                col = x / 20;
            } while ((matriz[lin][col] == 1) || (matriz[lin][col + 1] == 1) || (matriz[lin - 1][col + 1] == 1) || (matriz[lin - 2][col + 1] == 1));
            this.verifCriaJogador(x, y, lin, col);

        }
    }

    public void verifCriaJogador(int x, int y, int lin, int col) {
        Rectangle n = new Rectangle(x, y, nave.getLargura(), nave.getAltura());
        for (Inimigos r : inimigos) {
            Rectangle i = new Rectangle(r.posx, r.posy, r.getLargura(), r.getAltura());
            if (n.intersects(i)) {
                do {
                    x = this.sorteio.nextInt(462) + 80;
                    col = x / 20;
                } while ((matriz[lin][col] == 1) || (matriz[lin][col + 1] == 1) || (matriz[lin - 1][col + 1] == 1) || (matriz[lin - 2][col + 1] == 1));
                nave = new Jogador(x, y, KeyEvent.VK_UP, KeyEvent.VK_DOWN,
                        KeyEvent.VK_RIGHT, KeyEvent.VK_LEFT, KeyEvent.VK_SPACE, principal, "nave");
                break;
            } else {
                nave = new Jogador(x, y, KeyEvent.VK_UP, KeyEvent.VK_DOWN,
                        KeyEvent.VK_RIGHT, KeyEvent.VK_LEFT, KeyEvent.VK_SPACE, principal, "nave");
                break;
            }
        }
    }

    public void criaInimigos() {
        // criar inimigos
        //relogio para definir a velocidade de criação dos retangulos vermelhos
        if (relogio % 100 == 0) {//relogio para definir a velocidade que os inimigos são criados
            int col = -1;
            int x = 0;
            do {

                x = this.sorteio.nextInt(462) + 80;//sorteia coordenada x em que  o inimigo será criado
                col = x / 20; //pega a coord e divide pelo tamanho dos blocos para achar qual a coluna que o inimigo esta


            } while ((matriz[0][col] == 1) || (matriz[0][col + 1] == 1)); // enquanto a posição for 1 (grama) não cria o inimigo

            inimigos.add(new Inimigos(x, this.posY, this, "inimigo2"));//cria inimigo

            relogio = 0;
        }
        relogio++;
    }

    public void criaPosto() {
        //cria posto combustivel
        //relogio para definir a velocidade de criação dos postos
        if (relogioComb % 300 == 0) {//relogio para definir a velocidade que os postos são criados
            int col = -1;
            int x = 0;
            do {

                x = this.sorteio.nextInt(462) + 80;//sorteia coordenada x em que  o postos será criado
                col = x / 20; //pega a coord e divide pelo tamanho dos blocos para achar qual a coluna que o posto esta

            } while ((matriz[0][col] == 1) || (matriz[0][col + 1] == 1)); // enquanto a posição for 1 (grama) não cria o posto

            posto.add(new Posto(x, this.posY, this, "posto"));//cria posto
            relogioComb = 0;
        }
        relogioComb++;
    }

    public void criaTiro() {
        //criar tiro
        if (nave.atirar() == true) {
            tiro.add(new Tiro(nave.posx + 7, nave.posy - 5, this, "tiro"));
        }
    }

    public void atualizaCoordInimigos() {
        // atualizar coordenadas do arraylist de ret vermelho
        for (Inimigos r : inimigos) {
            if (r.posy > 494) {
                inimigos.remove(r);
                break;
            }
            r.atualizarCoord(this);
        }
    }

    public void atualizaCoordTiro() {
        //atualizar coordenada do tiro
        for (Tiro t : tiro) {
            if (t.posy < 0) {
                tiro.remove(t);
                break;
            }
            t.atualizarCoord();
        }
    }

    public void atualizaCoordPosto() {
        // atualizar coordenadas do arraylist do posto
        for (Posto po : posto) {
            if (po.posy > 494) {
                posto.remove(po);
                break;
            }
            po.atualizarCoord();
        }
    }

    public void atualizaCoordJogador() {
        // atualizar coordenadas do jogador
        int c = -1;
        int x = 0;
        int l = -1;

        int p = this.nave.getPosx();
        int tamanho = 20;
        c = p / tamanho;

        int s = this.nave.getPosy();
        l = s / tamanho;

        this.nave.atualizarCoord();
        if ((matriz[l][c] != 0) || (matriz[l][c + 1] != 0)) {
            this.perdeVida();
        }
    }

    public void colidiuTiroInimigo() {
        // verificar colisoes entre tiros e retangulos vermelhos
        boolean v = false;
        for (Tiro ti : tiro) {
            Rectangle rec1 = new Rectangle(ti.posx, ti.posy, ti.getLargura(), ti.getAltura());
            for (Inimigos r : inimigos) {
                Rectangle s = new Rectangle(r.posx, r.posy, r.getLargura(), r.getAltura());
                if (rec1.intersects(s)) {
                    inimigos.remove(r);
                    this.pontos++;
                    String pontosString = "" + pontos;
                    principal.jTFpontos.setText(pontosString);
                    v = true;
                    break;
                }
            }
            if (v == true) {
                tiro.remove(ti);
                v = false;
                break;
            }
        }
    }

    public void colidiuTiroPosto() {
        boolean v = false;
        for (Tiro ti : tiro) {
            Rectangle rec1 = new Rectangle(ti.posx, ti.posy, ti.getLargura(), ti.getAltura());
            for (Posto p : posto) {
                Rectangle s = new Rectangle(p.posx, p.posy, p.getLargura(), p.getAltura());
                if (rec1.intersects(s)) {
                    posto.remove(p);
                    this.pontos++;
                    String pontosString = "" + pontos;
                    principal.jTFpontos.setText(pontosString);
                    v = true;
                    break;
                }
            }
            if (v == true) {
                tiro.remove(ti);
                v = false;
                break;
            }
        }
    }

    public void colidiuNaveInimigo() {
        //verificar se a nave bate em algum vermelho
        Rectangle rec = new Rectangle(nave.posx, nave.posy, nave.getLargura(), nave.getAltura());
        for (Inimigos r : inimigos) {
            Rectangle s = new Rectangle(r.posx, r.posy, r.getLargura(), r.getAltura());
            if (rec.intersects(s)) {
                this.perdeVida();
                break;
            }
        }
    }

    public void colidiuNavePosto() {
        //verificar colisão entre nave e posto
        Rectangle rec2 = new Rectangle(nave.posx, nave.posy, nave.getLargura(), nave.getAltura());
        for (Posto po : posto) {
            Rectangle s = new Rectangle(po.posx, po.posy, po.getLargura(), po.getAltura());
            if (rec2.intersects(s)) {
                nave.aumentaComb();
                break;
            }
        }
    }

    public void perdeVida() {

        nave.explode("explosao");
        this.vidas--;
        String vidas1 = ("" + this.vidas);
        principal.jTFvidas.setText(vidas1);
        timer.stop();
        //this.inimigos.clear();
        
        if (this.vidas < 0) {

            jDGameOver dialogo = new jDGameOver(principal, true);
            String p = ("" + this.pontos);
            dialogo.jTFpontos.setText(p);
            dialogo.setLocationRelativeTo(null);
            dialogo.setVisible(true);
        }
    }

    private void processarLogica() {

        if (relogio % 20 == 0) {//relogio para definir a taxa de atualização do cenario
            this.atualizarCenario();
        }

        this.criaInimigos();
        this.criaPosto();
        this.criaTiro();

        this.atualizaCoordInimigos();
        this.atualizaCoordTiro();
        this.atualizaCoordPosto();
        this.atualizaCoordJogador();

        this.colidiuNaveInimigo();
        this.colidiuNavePosto();
        this.colidiuTiroInimigo();
        this.colidiuTiroPosto();

    }

    public void actionPerformed(ActionEvent ae) {
        this.principal.teclado.poll(); // processa os eventos no teclado
        this.processarLogica(); // atualiza as coordenadas dos elementos
        this.repaint();
    }

    public void desenharCenario(Graphics g) {
        for (int i = 0; i < 25; i++) { // linhas
            for (int j = 0; j < 32; j++) { // colunas
                g.drawImage(this.imgcenarios[this.matriz[i][j]], this.larguraBloco * j, this.larguraBloco * i, this.principal);
            }
        }
    }
}